<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFeeType1 ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfFeeType1 extends AbstractStructArrayBase
{
    /**
     * The Charge
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgFeeType[]
     */
    public $Charge;
    /**
     * Constructor method for ArrayOfFeeType1
     * @uses DgArrayOfFeeType1::setCharge()
     * @param \dgsoft\StructType\DgFeeType[] $charge
     */
    public function __construct(array $charge = array())
    {
        $this
            ->setCharge($charge);
    }
    /**
     * Get Charge value
     * @return \dgsoft\StructType\DgFeeType[]|null
     */
    public function getCharge()
    {
        return $this->Charge;
    }
    /**
     * Set Charge value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgFeeType[] $charge
     * @return \dgsoft\ArrayType\DgArrayOfFeeType1
     */
    public function setCharge(array $charge = array())
    {
        foreach ($charge as $arrayOfFeeType1ChargeItem) {
            // validation for constraint: itemType
            if (!$arrayOfFeeType1ChargeItem instanceof \dgsoft\StructType\DgFeeType) {
                throw new \InvalidArgumentException(sprintf('The Charge property can only contain items of \dgsoft\StructType\DgFeeType, "%s" given', is_object($arrayOfFeeType1ChargeItem) ? get_class($arrayOfFeeType1ChargeItem) : gettype($arrayOfFeeType1ChargeItem)), __LINE__);
            }
        }
        $this->Charge = $charge;
        return $this;
    }
    /**
     * Add item to Charge value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgFeeType $item
     * @return \dgsoft\ArrayType\DgArrayOfFeeType1
     */
    public function addToCharge(\dgsoft\StructType\DgFeeType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgFeeType) {
            throw new \InvalidArgumentException(sprintf('The Charge property can only contain items of \dgsoft\StructType\DgFeeType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Charge[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgFeeType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgFeeType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgFeeType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgFeeType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgFeeType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Charge
     */
    public function getAttributeName()
    {
        return 'Charge';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfFeeType1
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
